function err = alterrmul(achoice,xnow,xgrid,apol,par,gh,step,options)

%If last step
if step == 1,
    n = length(achoice); err = zeros(n,1);
    for i = 1:n,
        xnext   = exp(par.mu+sqrt(2)*par.sigma*gh.e)+achoice(i);
        anext   = interp1(xgrid,apol,xnext,'*linear','extrap');
        expec   = (1+par.r)*par.beta*sum(gh.w.*(xnext-anext/...
                  (1+par.r)).^(-par.gamma))/sqrt(pi);
        err(i)  = -par.gamma*log(xnow(i)-achoice(i)/(1+par.r))-log(...
                  expec+par.eta2+par.eta1*exp(-par.eta0*achoice(i)));
    end
    return
end

%If not last step
n = length(achoice); err = zeros(n,1);
for i = 1:n,
    xnext   = exp(par.mu+sqrt(2)*par.sigma*gh.e)+achoice(i);
    initial = interp1(xgrid,apol,xnext,'*linear','extrap');
    anext   = fsolve(@(anext) alterrmul(anext,xnext,xgrid,apol,...
              par,gh,step-1,options),initial,optimset(options,...
              'JacobPattern',speye(length(initial))));
    expec   = (1+par.r)*par.beta*sum(gh.w.*(xnext-anext/...
              (1+par.r)).^(-par.gamma))/sqrt(pi);
    err(i)  = -par.gamma*log(xnow(i)-achoice(i)/(1+par.r))-log(...
              expec+par.eta2+par.eta1*exp(-par.eta0*achoice(i)));
end

end